org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class MathStep<S>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<S,Double>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MathStep<S>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Double>>, Step<S,Double>, ByModulating, PathProcessor, Scoping, TraversalParent

      public final class MathStep<S>
      extends MapStep<S,Double>
      implements ByModulating, TraversalParent, Scoping, PathProcessor

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `Scoping.Variable`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `PathProcessor.ElementRequirement`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MathStep(Traversal.Admin traversal, String equation)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MathStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `Set<String>` | `getKeepLabels()`
    `List<Traversal.Admin<S,Number>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `Set<String>` | `getScopeKeys()` Get the labels that this scoping step will access during the traversal
    `protected static Set<String>` | `getVariables(String equation)`
    `int` | `hashCode()`
    `protected Double` | `map(Traverser.Admin<S> traverser)`
    `void` | `modulateBy(Traversal.Admin<?,?> selectTraversal)`
    `protected Traverser.Admin<Double>` | `processNextStart()`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setKeepLabels(Set<String> labels)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getTraversal, hasNext, next, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `getNullableScopeValue, getScopeValue`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `getMaxRequirement, processTraverserPathLabels`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### MathStep

          public MathStep(Traversal.Admin traversal,
                          String equation)

  - ### Method Detail

    - #### processNextStart

          protected Traverser.Admin<Double> processNextStart()

      Overrides:
        `processNextStart` in class `MapStep<S,Double>`

    - #### map

          protected Double map(Traverser.Admin<S> traverser)

      Specified by:
        `map` in class `MapStep<S,Double>`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> selectTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Double>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Double>`

    - #### getLocalChildren

          public List<Traversal.Admin<S,Number>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,Double>`
      Overrides:
        `reset` in class `AbstractStep<S,Double>`

    - #### clone

          public MathStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when reset() is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Double>`
      Overrides:
        `clone` in class `AbstractStep<S,Double>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Double>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Double>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Double>`
      Returns:
        the set of requirements

    - #### getScopeKeys

          public Set<String> getScopeKeys()

      Description copied from interface: `Scoping`
      Get the labels that this scoping step will access during the traversal
      Specified by:
        `getScopeKeys` in interface `Scoping`
      Returns:
        the accessed labels of the scoping step

    - #### setKeepLabels

          public void setKeepLabels(Set<String> labels)

      Specified by:
        `setKeepLabels` in interface `PathProcessor`

    - #### getKeepLabels

          public Set<String> getKeepLabels()

      Specified by:
        `getKeepLabels` in interface `PathProcessor`

    - #### getVariables

          protected static final Set<String> getVariables(String equation)

Copyright © 2013–2018 Apache Software Foundation. All rights reserved.